
#include<gmp.h>
#include<stdio.h>
#include<stdlib.h>


int restoChines (mpz_t a[], mpz_t n[], int M, mpz_t x){
	mpz_t N;
	mpz_t tmp;
	mpz_t inverso;
	int i;
	mpz_inits (tmp, inverso, NULL); /* x = tmp = inverso = 0 */
	mpz_init_set (N, n[0]);  /* N = n[0] */

	for (i = 1; i < M; i++){	/* N = n[0] * n[1] * .. * n[M - 1] */
		mpz_mul (N, N, n[i]);
	}

	for (i = 0; i < M; i++){
		mpz_divexact (tmp, N, n[i]); /* tmp = N/n[i] */
		if (mpz_invert (inverso, tmp, n[i])){ /* inverso = tmp^-1 (mod n[i]) */
			mpz_mul (tmp, tmp, a[i]);
			mpz_mul (tmp, tmp, inverso);
			mpz_add (x, x, tmp);	/* x += tmp * a[i] * inverso */
		}else{  /* se no conseguiu calcular o inverso */
			return 0;
		}
	}
	
	mpz_mod (x, x, N);
	return 1;
}


int main (int argc, char** argv){
	mpz_t* a;
	mpz_t* n;
	mpz_t x;
	int qnt = (argc - 1)/2;
	int i;
	mpz_init (x);
	if (argc > 1){
		a = malloc (qnt * sizeof (mpz_t));
		n = malloc (qnt * sizeof (mpz_t));
		for (i = 0; i < qnt; i++){
			mpz_init_set_str (a[i], argv[1 + i], 10);
		}
		for (; i < qnt + qnt; i++){
			mpz_init_set_str (n[i - qnt], argv[1 + i], 10);
		}
		if (restoChines (a, n, qnt, x))
			gmp_printf ("x = %Zd\n", x);
		else
			printf ("null\n");
	}
	return 0;
}

