/* ---------------------------------------------------------
*
*   Módulo para comunicação entre módulos e content scripts.
*
*
*
*   @author: Hilder Vitor Lima Pereira
*   
* -------------------------------------------------- */

exports.enviaMensagem = enviaMensagem;
exports.leDadosParaCriarUser = leDadosParaCriarUser;
exports.leDadosParaCriarAmizade = leDadosParaCriarAmizade;
exports.notifica = notifica;
exports.leCampoComFoco = leCampoComFoco;
exports.teste = teste;
exports.lerNomeESenha = lerNomeESenha;
exports.varreEDescriptografa = varreEDescriptografa;

// =========================================================
//      Variáveis globais
// =========================================================
var cript = require ("../encript");
var self = require("sdk/self");
var workers = require("sdk/content/worker");
let worker =  workers.Worker({
                window: require("sdk/window/utils").getMostRecentBrowserWindow(),
                contentScriptFile: [self.data.url("recebeDados.js")] //, self.data.url("decript.js")]
              });


// ==========================================================
//      Declaração e implementação das funções
// ==========================================================
var elemento = null;
worker.port.on ("guardarFoco", function (el){
    elemento = el;
});


/********************************************************************
 *      Recebe um worker. Envia uma mensagem para
 * a página referente a este worker w dizendo para
 * a percorrer os elementos e descriptografar o que for preciso.
 * 
 *      (executada pelo módulo main.js, no onAttach do pageMod)
 ******************************************************************/
var chave;
 
function varreEDescriptografa (w, cont, key){
    //   Executada quando o script 'decript.js' 
    // encontra algum elemento que precisa ser
    // descriptografado.
    
    chave = key;
    
    if (cont == 0){
        w.port.emit ('pegaProximo', "primeiro");
    }else {
        w.port.emit ('pegaProximo', "");
    }
    
    w.port.on ('descriptografa', function (texto){
        if (texto != null){
            console.log ("\n\n ------------------------------- \n WOOOOOOOOWWWWWWW \n ======================");
            console.log ("Recebeu este texto para descriptografar: " + texto);
            texto = texto.replace ('$c$', '', 'g');
            console.log ("vai descriptografar o texto " + texto);
            texto = cript.descriptografaAes (chave, texto)
            w.port.emit ('resposta.descriptografa', texto);
        }
    });
    w.port.on ('aindaTemElementos', function (){
        w.port.emit ('pegaProximo', "");
        //varreEDescriptografa (w);
    });
}




function teste (){
    console.log ("ELEMENTO: " + elemento);
    worker.port.emit ("elementoComFoco", "");
    
    worker.port.on ('criptografar', function (texto){
        console.log ("\n\nComunicador recebeu: " + texto + "\n\n");
        texto = cript.encripta(texto);
        worker.port.emit ('resposta.criptografar', texto);
    });

}


function enviaMensagem (msg){
    worker.port.emit ('alert', msg);
}

function recebeMensagem (msg, arg, callback){
    worker.port.on (msg, callback (arg));
}

function leCampoComFoco(){
    worker.port.emit ('leCampoComFoco', "");
}

function leDadosParaCriarAmizade(callBack){
    worker.port.emit ('leDadosParaCriarAmizade',"");
    worker.port.on ('resposta.leDadosParaCriarAmizade', function (nome){
            callBack(nome);
        });
}

function leDadosParaCriarUser (callback){
    worker.port.emit ('leDadosParaCriarUser', "");
    worker.port.on ('resposta.leDadosParaCriarUser', function (user) {
                                callback (user)});
    
}

/**
 * Painel para pegar nome e senha do
 * usuário 
 ***/
var data = require("sdk/self").data;

var painel = require("sdk/panel").Panel({
  width: 300,
  height: 350,
  position: {
   bottom: 10,
   right: 10
  },
  contentScriptFile: data.url("get-text.js"),
  contentURL: data.url("text-entry.html")
});

// quando o painel for mostrado na tela:
painel.on("show", function() {
  painel.port.emit("show");
});

function lerNomeESenha (callBack){
    console.log ("show panel!!!");
    painel.show();

    painel.port.on("text-entered", function (text) {
        usr = JSON.parse(text);
        callBack (usr.nome, usr.senha);
        console.log(text);
        painel.hide();
    });
}




/************************************************************
 *  Função para mostrar uma notificação simples no canto
 * superior direito da tela.
 *  Esta notificação tem o título igual a <titulo> e o
 * corpo igual a <msg>
 *********************************************************/
function notifica (titulo, msg){
    var notifications = require("sdk/notifications");
    notifications.notify({
    title: titulo,
    text: msg,
    iconURL: "http://upload.wikimedia.org/wikipedia/commons/a/af/Tux.png",
    /* descomentar estas linhas para executar a função quando for clicado
    data: "NADA",
    onClick: function (data) {
        console.log(data);
    } */
});
}