exports.criptografaAes = criptografaAes;
exports.descriptografaAes = descriptografaAes;
exports.geraChaveDeSessao = geraChaveDeSessao;
//exports.geraChavesRsa = geraChavesRsa;
exports.descriptografaRsa = descriptografaRsa;
exports.criptografaRsa = criptografaRsa;

var math = require ("./math_lib");


var base64 = require("sdk/base64");

var sjcl = require ("./StanfordJavascriptCryptoLib");

/*
    bijeção entre o conjunto de caracteres base 64 e um subconjunto dos naturais no qual
    cada elemento tem dois algarismos
    
    valueOfChar: Base64 --> Subconjunto dos naturais
    charOfValue: Subconjunto dos naturais --> Base64

    valueOfChar é o inverso de charOfValue.
*/
var valueOfChar =  {'a':70,'b':71,'c':72,'d':73,'e':74,'f':75,'g':76,'h':77,
                    'i':78,'j':79,'k':10,'l':11,'m':12,'n':13,'o':14,'p':15,
                    'q':16,'r':17, 's':18,'t':19,'u':20,'v':21,'w':22,'x':23,
                    'y':24,'z':25,'A':26,'B':27,'C':28,'D':29,'E':30,'F':31,
                    'G':32,'H':33,'I':34,'J':35,'K':36,'L':37,'M':38,'N':39,
                    'O':40,'P':41,'Q':42,'R':43,'S':44,'T':45,'U':46,'V':47,
                    'W':48,'X':49,'Y':50,'Z':51,'0':52,'1':53,'2':54,'3':55,
                    '4':56,'5':57,'6':58,'7':59,'8':60,'9':61,'/':62,'+':63, '=':64};

// criando charOfValue
var charOfValue = {};
var keys = Object.keys(valueOfChar);
for (i = 0; i < keys.length; i++){
    charOfValue[valueOfChar[keys[i]]] = keys[i];
}


/***********************************************
*   Recebe uma string qualquer e devolve uma
* sequência de algarismos. Para isto, usa a tabela  valueOfChar.
***************************************************/
function str2Int (str){
    str = base64.encode(str, "utf-8");
    num = "";
	for (i = 0; i < str.length; i++){
		c = str.charAt(i);// - String.charCodeAt('A');
        console.log ("\nc: " + c + "\n");
		c = valueOfChar[c];
		num = (c + num);
	}
	return num;
}


/********************************************************************
*   Função inversa da função str2Text.
*   Recebe uma sequência de algarismos e devolve uma string.
*********************************************************************/
function int2Str (num){
	var str = "";
    for (i = num.length - 1; i >= 2; i -=2){
        c0 = num[i];
        c1 = num[i - 1];
        k = parseInt(c0 + "" + c1);
        str += charOfValue[k];
    }
    return base64.decode(str, "utf-8");
}


function criptografaAes (usuario, msg){
    /* 
    {"iv":"1jg5eEbmJEGTax/d7rxIKQ==","v":1,"iter":1000,"ks":128,"ts":64,
    "mode":"ccm","adata":"","cipher":"aes","salt":"GvhktHtYcOg=","ct":"lgtNMtELedp9OodFjFIBNmK2ykmpI5WY"} */

    c = JSON.parse (sjcl.encrypt (usuario.chaveDeSessao + "", msg));
    return '$c$' + base64.encode(usuario.id + ',' + c.iv + ',' + c.salt + ',' + c.ct) + '$c$';
}

function descriptografaAes (chave, msg){
    console.log ("descriptografaAes:\n chave =  " + chave + "\n msg = " + msg);
    v =  base64.decode(msg).split(',');
    text = '{"iv":"'+v[1]+'","v":1,"iter":1000,"ks":128,"ts":64,"mode":"ccm","adata":"","cipher":"aes","salt":"'+v[2]+'","ct":"'+v[3]+'"}';
    return sjcl.decrypt (chave, text);
}

/***
 *  Gera uma chave de sessão para ser usada pelo algoritmo 3DES.
 *  A chave gerada tem 256 bits.
 ***********************************************/
function geraChaveDeSessao(){
    var chave = "0";
    while (chave == "0"){
        chave = math.geraAleatorio(128);
    }
    return chave;
}


/**************************************************************
 *      executa a criptografia RSA em msg supondo que msg é uma
 * string representando um inteiro de 128.
 **************************************************************/
function criptografaRsa (e, n, msg){
    return math.potenciaMod (msg, e, n);
}


/**************************************************************
 *      executa a descriptografia RSA em msg supondo que msg é uma
 * string que inicialmente tinha 128 bits e foi criptografada pelo
 * algoritmo acima.
 **************************************************************/
function descriptografaRsa (d, n, msg){
    return math.potenciaMod (msg, d, n);
}
