/* ------------------------------------------------
*
*   Módulo para gerenciar contas de usuários.
*
*
*   @author: Hilder Vitor Lima Pereira
*   
* -------------------------------------------------- */


// =======================================================
//      Funções exportadas
// =======================================================

exports.cadastraUsuario = cadastraUsuario;
exports.cadastraAmigo = cadastraAmigo;


// =========================================================
//      Variáveis globais
// =========================================================
var bd = require ("./bd_manager"); // acesso ao banco de dados
var cm = require ("controller/comunicador");
var lm = require ("./math_lib.js");
var self = require("sdk/self");

var user = null;

// ==========================================================
//      Declaração e implementação das funções
// ==========================================================

/*******************************************************************
*   Cadastra um usuário no sistema.
*   Os dados do usuário cadastrado são passados a função getDados
********************************************************************/
function cadastraUsuario(nome, email, senha, getDados){
    
    // seleciona o usuário pelo nome e executa a função sobre a resposta
    // do banco de dados (o parâmetro usuario)
    var usuario = bd.selecionaUsuarioPorNomeRemoto (nome, function (usuario){
        
        if (usuario != null){
            cm.enviaMensagem ("Usuário já existe: " + usuario.nome);
            // TODO: selecionar demais dados, como chave e grupo e gravar no banco local.
        }else {
            cm.enviaMensagem ("Vai criar usuário");
            // le nome, email e senha e executa esta função anônima
            // sobre o objeto user, que tem os dados lidos.
            cm.leDadosParaCriarUser (function (user) {
               //try{
                    
                    user = JSON.parse (user);
                    cm.notifica ("Gerando chaves", "Gerando as chaves públicas e privadas. Isto pode demorar um pouco...");
                    md5Senha = lm.md5(user.senha);
                    
                    [g, a, x] = lm.geraChaves();
                    bd.inserirUsuario (user.nome, user.email, md5Senha, g, a, x);
                    getDados (user);
                //}catch (SyntaxError){
                  // cm.enviaMensagem ("ERRO DE SINTAXE: ao criar conta\n");
                   //getDados (null);
                //}
            });
        }
    });
}


function cadastraAmigo (nomeUsuario){
    // le o nome do amigo e o trata nesta funcção nônima.
    cm.leDadosParaCriarAmizade(function (nomeAmigo){
        if (nomeAmigo == null){
            cm.notifica ("Usuário inválido.", "O nome de usuário digitado não é um nome válido.");
        }else{
            bd.inserirAmizade (nomeUsuario, nomeAmigo);
        }
    });
}

/***********************************************************
*   Carrega as informações referentes ao usuário e guarda
* na variável global user.
************************************************************/
function carregaInformacoesConta (nome){
    
}