var data = require("sdk/self").data;

var pageMod = require("sdk/page-mod");

var widgets = require("sdk/widget");

var self = require("sdk/self");
var Request = require("sdk/request").Request;
var math = require ("./math_lib");
var bd = require ("./bd_manager");
var cm = require ("./controller/comunicador");

var work;
var workers = require("sdk/content/worker");


var ger = require("./gerenciador_contas");
var Usuario = require("./usuario");
var cript = require ("./encript");

var usuario = null;

/*************************************************************************
 *      Função executada quando o Firefox é inicializado,
 * quando esta extensão é instalada, ativada, atualizada, etc...
 *      É executada após o arquivo main.js ser lido inteiro, ou seja,
 * quando esta função é executada, todos os módulo já foram carregados.
 * 
 *      Para mais informações, ver 
 *   addons.mozilla.org/en-US/developers/docs/sdk/Firefox-24/dev-guide/tutorials/load-and-unload.html
 *
 *************************************************************************/
exports.main = function (options, callbacks) {
    
    if ((options.loadReason == "install") || //quando o add-on é instalado OU
        (options.loadReason == "enable") || // quando o add-on é ativado OU
        (options.loadReason == "startup")){  // quando o firefox é aberto
        
        bd.criarBancoDeDadosLocal();
        
        // mostra um painel para ler o nome e a senha
        cm.lerNomeESenha(function (nome, senha){
            
            // função de callBack 'getUser' definida no fim deste arquivo
            bd.selecionaUsuarioPorNome (nome, getUser);
            //[n, e, d] = math.geraChavesRsa();
            //x = math.restoChines (b, m);
            //console.log ("---- X = " + x);
        
        });
    }else if (options.loadReason == "upgrade"){
        // Não faz nada por enquanto
    }else if (options.loadReason == "downgrade"){
        // Não faz nada por enquanto
    }
    
}


// tecla de atalho
var { Hotkey } = require("sdk/hotkeys"); 
var showHotKey = Hotkey({
  combo: "control-space", // CRTL + ESPAÇO
  onPress: function() {
    console.log ("CONTROL + ESPAÇO");
    if (usuario == null){
        cm.notifica("Erro de autenticação.", "Antes de criptografar os dados, é necessário se autenticar.");
    }else{
        let worker =  workers.Worker({
                        window: require("sdk/window/utils").getMostRecentBrowserWindow().gBrowser.contentWindow,
                        contentScriptFile: self.data.url("recebeDados.js")
                      });
       // avisa que quer pegar o elemento que tem o foco
       worker.port.emit ("getFocused", "");
       // espera enviar o texto do elemento
       worker.port.on("mudar", function (text){
            
            text = cript.criptografaAes (usuario,text);
            console.log ("\n\n TEXTO CRIPTOGRAFADO: " + text + "\n\n");
            worker.port.emit ('resposta.mudar', text);
        });

    }
  }
});



var widget = widgets.Widget({
  id: "vitor_lima_linux_website",
  label: "Pegar dados",
  contentURL: "http://upload.wikimedia.org/wikipedia/commons/a/af/Tux.png",
  contentScriptFile: self.data.url("recebeDados.js"),
  onAttach: function(worker){
     work = worker;
  },
  onClick: function() {

    ger.cadastraUsuario ("vitoria", "teste", "teste", function (user) {
        usuario = user;
    //    work.port.emit('alert', usuario.nome);
//        cadastraAmigos (usuario.nome);
    });
  }
});


var widget2 = widgets.Widget({
  id: "vitor_lima_linux_website2",
  label: "Cadastrar amigos",
  contentURL: "http://loole.doomby.com/medias/album/images/opensec-tux-mario-1732.png",
  contentScriptFile: self.data.url("recebeDados.js"),
  onAttach: function(worker){
     work = worker;
  },
  onClick: function() {
    //cm.enviaMensagem ("MEU NOME: " + usuario.nome);
    ger.cadastraAmigo (usuario.nome);
    
  }
});



pageMod.PageMod({
  include: ["*"],
  contentScriptFile: [data.url("decript.js")],// data.url("cript.js")],
                        //data.url("recebe_dados.js")],
  // quando o script 'decript.js' for afixado na página
  onAttach: function(worker){
        if (usuario != null)
            cm.varreEDescriptografa(worker, 0, usuario.chaveDeSessao + "");
  }
});



/**
*   Função passada como callBack para a função 'selecionaUsuarioPorNome' quando esta
* é chamada na função main deste módulo.
*   
*   Olhe a função bd_manager.selecionaUsuarioPorNome para entender o formato da entrada
* desta função (ela espera exatamente a saída desta função que faz o select).
****/
function getUser(usrTmp){
    if (usrTmp != null){
        usuario = Usuario.novoUsuario (usrTmp.id, usrTmp.email, usrTmp.senha, usrTmp.id);
        
        usuario.chavePrivada = usrTmp.chavePrivada;
        for (i = 0; i < usrTmp.qntAmigos; i++){
            usuario.coprimo[i] = usrTmp.coprimo[i]
            usuario.chaveAmigoG[i] = usrTmp.chaveAmigoG[i];
            usuario.chaveAmigoA[i] = usrTmp.chaveAmigoA[i];
        }
        usuario.chaveDeSessao = cript.geraChaveDeSessao();
        cm.notifica ("Autenticação completada.", usuario.nome + ", sua autenticação foi feita com sucesso. \n Chave de Sessão: " + usuario.chaveDeSessao);
    }else { // usuario == null
        cm.notifica ("Falha de autenticação.", "Ocorreu um erro ao tentar autenticar o seu usuário.");
        console.log ("NAO ACHOU");
    }
    
}