/* ------------------------------------------------
*
*   Módulo para modelar um usuário.
*
*   Este módulo serve como uma classe do tipo Usuario.
*   Um objeto desta classe tem as principais informações sobre
* um usuário (como nome, senha, chaves públicas e privada, coprimos dos contatos,...)
*
*
*   @author: Hilder Vitor Lima Pereira
*   
* -------------------------------------------------- */


// =======================================================
//      Funções exportadas
// =======================================================



exports.novoUsuario = function (name, mail, passwd, ident){
    return new Usuario (name, mail, passwd, identi);
}


/**
*   Construtor:
**********************/
var Usuario = function (name, mail, passwd, identidade){
    this.id = identidade;
    this.nome = name;
    this.email = mail;
    this.senha = passwd;
    this.chavePrivada = null;
    this.g = null;
    this.a = null;
    this.chaveDeSessao = 0;
    
    // cada tripla (coprimo[i], amigo_g[i], amigo_a[i]) 
    // representa os dados referentes a amizade com o i-ésimo amigo.
    this.coprimo = new Array();
    this.chaveAmigoG = new Array();
    this.chaveAmigoA = new Array();
};


Usuario.prototype.addChavesPublicas = function (chave_publica_g, chave_publica_a){
    this.g = chave_publica_g;
    this.a = chave_publica_a;
};

/****************************************************
*   Recebe um número primo p.
*   Se este número já estiver na lista de coprimos deste
* usuário, então, não adiciona p e devolve false.
*   Se p ainda não estiver na lista, então, adiciona p
* e devolve true.
******************************************************/
Usuario.prototype.addCoprimo = function (p){
    size = this.coprimo.length;
    for (i = 0; i < size; i++){
        if (p == this.coprimos[i])
            return false;
    }
    this.coprimo[size] = p;
    return true;
};

Usuario.prototype.getQntAmigos = function (){
    console.log ("FROM usuario.js");
    return this.coprimo.length;
}

exports.novoUsuario = function novoUsuario (name, mail, passwd){
    return new Usuario (name, mail, passwd);
}